//+------------------------------------------------------------------+
//|                                        Advance_Decline_Ratio.mq5 |
//|                                            Copyright Magnumfreak |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Magnumfreak"
#property link      ""
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//---- plot ADRLine
#property indicator_label1  "ADRLine"
#property indicator_type1   DRAW_LINE
#property indicator_color1  White
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
#property indicator_level1 1
#property indicator_levelcolor White
//--- input parameters
input int      LookBack=25;
//--- indicator buffers
double         ADRLineBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,ADRLineBuffer,INDICATOR_DATA);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
//---

   double goingup,goingdown;
   int limit = rates_total;
//----
   for(int i = limit;i>=0;i--)
   {
       goingup=0;
       goingdown=0;
       for(int y = LookBack;y>0;y--)
         {
         if(close[i+y] > open[i+y])goingup++;
         if(close[i+y] < open[i+y])goingdown++;
         }
      if(goingdown>0) ADRLineBuffer[i] = goingup/goingdown;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
